<!DOCTYPE html>
<html>
    <head>
        <title>Rosencan (Prototype)</title>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
        <script src="/socket.io/socket.io.js"></script>
    </head>
    <body>
        <p id="msg">Connecting to socket...</p>
        <button id="start" onclick="onStartClick()" disabled>Start Game</button>
        <button id="a1" onclick="onA1Click()" disabled></button>
        <button id="a2" onclick="onA2Click()" disabled></button>
        <br/>
        <button id="a3" onclick="onA3Click()" disabled></button>
        <button id="a4" onclick="onA4Click()" disabled></button>
        <br/>
        <button id="next" onClick="onNextClick()" disabled>Next Question</button>
        <script>
            /*eslint-env jquery */
            /*globals io */
            /*eslint-disable no-unused-vars */
            hideAnswerButtons();
            hideNextButton();
            var socket = io();
            
            socket.on("connMessage", function() {
               $("#msg").text("Connected!");
               console.log("Connected as " + socket.id); // debug line, plz ignore
               hideAnswerButtons();
               enableButtons();
               $("#start").show();
               hideNextButton();
            });
            
            function onStartClick() {
                $("#msg").text("Waiting for game to start...");
                $("#start").hide();
                disableButtons();
                socket.emit("startGame", "0");
                console.log("Waiting for loaded response...");
            }

            socket.on("loadedGame", function() {
                $("#msg").text("Game loaded, starting...");
                socket.emit("nextQuestionRequest");
            });

            socket.on("question", function(question) {
                $("#msg").text(question.text);
                $("#a1").text(question.answers[0].text);
                $("#a2").text(question.answers[1].text);
                $("#a3").text(question.answers[2].text);
                $("#a4").text(question.answers[3].text);
                enableButtons();
                showAnswerButtons();
            });
            
            socket.on("finished", function() {
                $("#msg").text("You've finished this game! Please refresh the page if you'd like to restart.");
            });
            
            socket.on("answerResponse", function(answer) {
                if (answer === true) {
                    $("#msg").text("Correct!");
                } else {
                    $("#msg").text(`Incorrect.\nThe correct answer was "${answer.text}".`);
                }
                hideAnswerButtons();
                enableButtons();
                showNextButton();
            });

            function onA1Click() {
                socket.emit("answer", 0);
                disableButtons();
            }
            
            function onA2Click() {
                socket.emit("answer", 1);
                disableButtons();
            }

            function onA3Click() {
                socket.emit("answer", 2);
                disableButtons();
            }

            function onA4Click() {
                socket.emit("answer", 3);
                disableButtons();
            }
            
            function onNextClick() {
                socket.emit("nextQuestionRequest");
                hideNextButton();
            }
            
            function disableButtons(){
                $("button").prop("disabled", true);
            }
            
            function enableButtons() {
                $("button").prop("disabled", false);
            }

            function showAnswerButtons() {
                $("#a1").show();
                $("#a2").show();
                $("#a3").show();
                $("#a4").show();
            }

            function hideAnswerButtons() {
                $("#a1").hide();
                $("#a2").hide();
                $("#a3").hide();
                $("#a4").hide();
            }
            
            function showNextButton() {
                $("#next").show();
            }
            
            function hideNextButton() {
                $("#next").hide();
            }
        </script>
    </body>
</html>